#include "StdAfx.h"
#include "AutoTextListHeaderItemUI.h"
#include "AutoTextListHeaderUI.h"


CAutoTextListHeaderItemUI::CAutoTextListHeaderItemUI(void)
{
	m_pHeader = NULL;
}

CAutoTextListHeaderItemUI::~CAutoTextListHeaderItemUI(void)
{
    //1540(lint)
    m_pHeader = NULL;
}

LPCTSTR CAutoTextListHeaderItemUI::GetClass() const
{
	return AUTO_TEXT_TEXT_HEADER_ELEMENT;
}

LPVOID CAutoTextListHeaderItemUI::GetInterface(LPCTSTR pstrName)
{
	if( _tcscmp(pstrName, AUTO_TEXT_TEXT_HEADER_ELEMENT) == 0 )
	{
		return (this);
	}

	return __super::GetInterface(pstrName);
}

void CAutoTextListHeaderItemUI::SetOwner(CAutoTextListHeaderUI *pHeader)
{
	m_pHeader = pHeader;
}

 void CAutoTextListHeaderItemUI::DoEvent(TEventUI& event)
 {
 	if( !IsMouseEnabled() && event.Type > UIEVENT__MOUSEBEGIN && event.Type < UIEVENT__MOUSEEND ) {
 		if( m_pParent != NULL ) m_pParent->DoEvent(event);
 		else CControlUI::DoEvent(event);
 		return;
 	}
 
	switch (event.Type)
	{
		case UIEVENT_SETFOCUS:
		case UIEVENT_KILLFOCUS:
		case UIEVENT_BUTTONDOWN:
		case UIEVENT_DBLCLICK:
		case UIEVENT_BUTTONUP:
		case UIEVENT_SETCURSOR:
		case UIEVENT_MOUSEENTER:
		case UIEVENT_MOUSELEAVE:
			{
				__super::DoEvent(event);
				return;
			}
		case UIEVENT_MOUSEMOVE:
			{
				if( (m_uButtonState & UISTATE_CAPTURED) != 0 ) 
				{
					RECT rc = m_rcItem;
					rc.right -= ptLastMouse.x - event.ptMouse.x;

					if( rc.right - rc.left > GetMinWidth() ) 
					{
						for (int k = 0; k < m_pHeader->GetCount(); k++)
						{
							CAutoTextListHeaderItemUI *pCurItem = (CAutoTextListHeaderItemUI*)m_pHeader->GetItemAt(k);
							if (pCurItem == this && k < m_pHeader->GetCount() - 1)
							{
								CAutoTextListHeaderItemUI *pNextItem = (CAutoTextListHeaderItemUI*)m_pHeader->GetItemAt(k + 1);
								RECT rcNextItem = pNextItem->GetPos();
								rcNextItem.left -= ptLastMouse.x - event.ptMouse.x;

								if (rc.right + pCurItem->GetTextPadding().right < rcNextItem.right)
								{
									pNextItem->SetFixedWidth(rcNextItem.right - rcNextItem.left);
								}
								else
								{
									return;
								}

								break;
							}
						}

						m_cxyFixed.cx = rc.right - rc.left;
						ptLastMouse = event.ptMouse;
						if( GetParent() ) 
							GetParent()->NeedParentUpdate();
					}
					m_pManager->SendNotify(this, DUI_MSGTYPE_HEADERDRAG);
				}
				return;
			}
	}
 
 	CControlUI::DoEvent(event);
 }
